#!/bin/sh
# $Id: mk-patchkit.sh,v 1.2 2002/10/28 23:35:09 mikpe Exp $

KVER=$1
PVER=$2

files_core="drivers/perfctr/Config.help drivers/perfctr/Config.in drivers/perfctr/Makefile drivers/perfctr/compat.h drivers/perfctr/init.c include/asm-i386/perfctr.h include/linux/perfctr.h"

files_kernel="CREDITS MAINTAINERS arch/i386/config.in arch/i386/kernel/entry.S arch/i386/kernel/i8259.c arch/i386/kernel/process.c arch/i386/mach-generic/irq_vectors.h drivers/Makefile include/asm-i386/apic.h include/asm-i386/processor.h include/asm-i386/unistd.h kernel/timer.c"

files_x86="drivers/perfctr/x86.c drivers/perfctr/x86_compat.c drivers/perfctr/x86_compat.h"

files_virtual="drivers/perfctr/virtual.c drivers/perfctr/virtual.h drivers/perfctr/virtual_compat.c drivers/perfctr/virtual_compat.h"

doit() {
    for f in $1 ; do
	echo "diff -uN linux-$KVER/$f linux-$KVER.perfctr-$PVER/$f"
	diff -uN linux-$KVER/$f linux-$KVER.perfctr-$PVER/$f
    done > patch-$KVER-perfctr-$PVER-$2
    diffstat patch-$KVER-perfctr-$PVER-$2 > diffstat.patch-$KVER-perfctr-$PVER-$2
}

doit "$files_core" "1.core"
doit "$files_kernel" "2.kernel"
doit "$files_x86" "3.x86"
doit "$files_virtual" "4.virtual"
