/* $Id: virtual_compat.h,v 1.2 2002/10/25 21:08:51 mikpe Exp $
 * Performance-monitoring counters driver.
 * Virtual perfctrs backwards compatibility support code.
 *
 * Copyright (C) 2002  Mikael Pettersson
 */
#include <linux/version.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,15)
extern int ptrace_check_attach(struct task_struct *child, int kill);
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
/* Gross hacks to simulate 2.5's get_sb_pseudo() and differently
   shaped struct file_system_type in 2.4. */

struct perfctr_file_system_type {
	const char *name;
	struct super_block *(*get_sb)(struct perfctr_file_system_type*, int, char*, void*);
	void (*kill_sb)(void);
};

extern int perfctr_register_filesystem(struct perfctr_file_system_type*);
extern void perfctr_unregister_filesystem(struct perfctr_file_system_type*);
extern struct vfsmount *perfctr_kern_mount(struct perfctr_file_system_type*);

#if !defined(IN_VIRTUAL_COMPAT_C)
/* Hack the name space seen in virtual.c */
#define file_system_type perfctr_file_system_type
static inline struct super_block *
get_sb_pseudo(struct file_system_type *fs_type,
	      const char *name, void *whatever, unsigned int magic)
{
	return NULL;
}
#define kill_anon_super (void(*)(void))0
#undef register_filesystem
#define register_filesystem(fs) perfctr_register_filesystem(fs)
#undef unregister_filesystem
#define unregister_filesystem(fs) perfctr_unregister_filesystem(fs)
#undef kern_mount
#define kern_mount(fs) perfctr_kern_mount(fs)
#endif	/* IN_VIRTUAL_COMPAT_C */

#endif	/* LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0) */
